#include "ttl_define.h"
#include "tt_list.h"
#include "tt_temporaly_array.h"

DWORD
TtList::GetStyle( void )
{
  return WS_TABSTOP;
}

DWORD
TtList::GetExtendedStyle( void )
{
  return WS_EX_CLIENTEDGE;
}

PCTSTR
TtList::GetClassName( void )
{
  return "LISTBOX";
}

int
TtList::GetCount() {
  return this->SendMessage( LB_GETCOUNT );
}

std::string
TtList::GetTextAt( unsigned int index )
{
  TtTemporalyString buf( this->SendMessage( LB_GETTEXTLEN, static_cast<WPARAM>( index ), 0 ) + 1 );
  this->SendMessage( LB_GETTEXT, index, reinterpret_cast<LPARAM>( buf.GetPtr() ) );
  return std::string( buf.GetPtr() );
}

int
TtList::GetCurrent( void )
{
  return this->SendMessage( LB_GETCURSEL );
}

int
TtList::Find( unsigned int start, const std::string& str )
{
  return this->SendMessage( LB_FINDSTRING, start, reinterpret_cast<LPARAM>( str.c_str() ) );
}

int
TtList::Push( const std::string& str )
{
  return this->SendMessage( LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( str.c_str() ) );
}

int
TtList::InsertAt( unsigned int index, const std::string& str )
{
  return this->SendMessage( LB_INSERTSTRING, index, reinterpret_cast<LPARAM>( str.c_str() ) );
}

int
TtList::DeleteAt( unsigned int index )
{
  return this->SendMessage( LB_DELETESTRING, index );
}

void
TtList::Clear( void )
{
  this->SendMessage( LB_RESETCONTENT );
}

int
TtList::GetSelectedCount( void )
{
  return this->SendMessage( LB_GETSELCOUNT );
}

bool
TtList::IsSelect( unsigned int index )
{
  return this->SendMessage( LB_GETSEL, index );
}

int
TtList::SetSelect( unsigned int index )
{
  return this->SendMessage( LB_SETSEL, TRUE, index );
}

int
TtList::UnsetSelect( unsigned int index )
{
  return this->SendMessage( LB_SETSEL, FALSE, index );
}

int
TtList::LockDraw( void )
{
  return this->SendMessage( WM_SETREDRAW, FALSE );
}

int
TtList::UnlockDraw( void )
{
  return this->SendMessage( WM_SETREDRAW, TRUE );
}
