#ifndef TT_SCROLL_H_
#define TT_SCROLL_H_

#include "tt_window.h"

// -- TtScroll -----------------------------------------------------------
class TtScroll : public TtWindow {
protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );

public:
  virtual int GetTrackPosition( void );
  virtual void SetTrackPosition( int position );

  virtual int GetMinimum( void );
  virtual void SetMinimum( int min );
  virtual int GetMaximum( void );
  virtual void SetMaximum( int max );
  virtual void SetRange( int min, int max );

  virtual int GetPageSize( void );
  virtual void SetPageSize( int page_size );

protected:
  bool GetInfo( void );
  void SetInfo( void );

  LRESULT Scrolling( int code, int position );

protected:
  SCROLLINFO info_;
};

// -- TtScrollVertical ---------------------------------------------------
class TtScrollVertical : public TtScroll {
protected:
  virtual DWORD  GetStyle( void );
  virtual LRESULT WMVerticalScrollReceived( int code, int position, HWND handle );
};

// -- TtScrollHorizontal -------------------------------------------------
class TtScrollHorizontal : public TtScroll {
protected:
  virtual DWORD  GetStyle( void );
  virtual LRESULT WMHorizontalScrollReceived( int code, int position, HWND handle );
};

// -- TtTrack ------------------------------------------------------------
class TtTrack : public TtScroll {
protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );

public:
  virtual int GetTrackPosition( void );
  virtual void SetTrackPosition( int position );

  virtual int GetMinimum( void );
  virtual void SetMinimum( int min );
  virtual int GetMaximum( void );
  virtual void SetMaximum( int max );
  virtual void SetRange( int min, int max );

  virtual int GetPageSize( void );
  virtual void SetPageSize( int page_size );

  int GetLineSize( void );
  void SetLineSize( int line_size );

  void SetTickFrequency( unsigned int frequency );
  void ClearTick( void );

protected:
  virtual LRESULT WMVerticalScrollReceived( int code, int position, HWND handle );
  virtual LRESULT WMHorizontalScrollReceived( int code, int position, HWND handle );
};

// -- TtTrackVertical ----------------------------------------------------
class TtTrackVertical : public TtTrack {
protected:
  virtual DWORD  GetStyle( void );
};

// -- TtTrackHorizontal --------------------------------------------------
class TtTrackHorizontal : public TtTrack {
protected:
  virtual DWORD  GetStyle( void );
};

#endif // TT_SCROLL_H_
