#include "ttl_define.h"
#include "tt_window_controls.h"

// -- TtStatic -----------------------------------------------------------
DWORD
TtStatic::GetStyle( void )
{
  return 0;
}

DWORD
TtStatic::GetExtendedStyle( void )
{
  return 0;
}

PCTSTR
TtStatic::GetClassName( void )
{
  return "STATIC";
}

// -- TtButton -----------------------------------------------------------
DWORD
TtButton::GetStyle( void )
{
  return WS_TABSTOP;
}

DWORD
TtButton::GetExtendedStyle( void )
{
  return 0;
}

PCTSTR
TtButton::GetClassName( void )
{
  return "BUTTON";
}

// -- TtButtonWithCheck --------------------------------------------------
bool
TtButtonWithCheck::GetCheck( void )
{
  return this->SendMessage( BM_GETCHECK );
}

int
TtButtonWithCheck::SetCheck( bool checking )
{
  return this->SendMessage( BM_SETCHECK, checking ? BST_CHECKED : BST_UNCHECKED );
}

// -- TtRadioButton ------------------------------------------------------
DWORD
TtRadioButton::GetStyle( void )
{
  return this->TtButtonWithCheck::GetStyle() | BS_AUTORADIOBUTTON;
}


// -- TtCheckBox ---------------------------------------------------------
DWORD
TtCheckBox::GetStyle( void )
{
  return this->TtButtonWithCheck::GetStyle() | BS_CHECKBOX | BS_AUTOCHECKBOX;
}

// -- TtGroup ------------------------------------------------------------
DWORD
TtGroup::GetStyle( void )
{
  return BS_GROUPBOX;
}

// -- TtEdit -------------------------------------------------------------
DWORD
TtEdit::GetStyle( void )
{
  return WS_TABSTOP | ES_AUTOHSCROLL;
}

DWORD
TtEdit::GetExtendedStyle( void )
{
  return WS_EX_CLIENTEDGE;
}

PCTSTR
TtEdit::GetClassName( void )
{
  return "EDIT";
}


void
TtEdit::SetReadOnly( bool flag )
{
  this->SendMessage( EM_SETREADONLY, flag ? TRUE : FALSE );
}


int
TtEdit::GetFirstVisibleLine( void )
{
  return this->SendMessage( EM_GETFIRSTVISIBLELINE );
}

// -- TtEditNumber -------------------------------------------------------
DWORD
TtEditNumber::GetStyle( void )
{
  return this->TtEdit::GetStyle() | ES_NUMBER;
}

// -- TtEditMultiline ----------------------------------------------------
DWORD
TtEditMultiline::GetStyle( void )
{
  return this->TtEdit::GetStyle() | ES_MULTILINE | ES_WANTRETURN;
}
