#ifndef TTL_DEFINE_H_
#define TTL_DEFINE_H_

#ifndef NOT_USE_VAR
#define NOT_USE_VAR( var ) ((void)var)
#endif

#ifndef NOT
#define NOT( v ) (!(v))
#endif

#define REAL_FUNC_NAME_OF( f ) (#f)
#ifdef DEBUG
#  define FUNC_NAME_OF( f ) ((void)(f), (*(f)) == ((f)), #f)
#else
#  define FUNC_NAME_OF( f ) (#f)
#endif

#ifdef DEBUG
#  include <stdio.h>
#  define PCD()            printf( "%s(%d) gone.\n", __FILE__, __LINE__ );
#  define PCA( type, obj ) printf( "%s(%d) : %s = " type "\n", __FILE__, __LINE__, #obj, obj )
#  define PCC( c )         PCA( "%c", c )
#  define PCI( i )         PCA( "%d", i )
#  define PCP( p )         PCA( "%p", p )
#  define PCS( s )         PCA( "%s", s )

#  include "tt_util.h"
#  define PMD()            TtUtil::MessageBoxForDebug( "", "gone", NULL, __FILE__, __LINE__ )
#  define PMA( type, obj ) TtUtil::MessageBoxForDebug( type, #obj, (void*)obj, __FILE__, __LINE__ )
#  define PMC( c )         PMA( "%c", c )
#  define PMI( i )         PMA( "%d", i )
#  define PMP( p )         PMA( "%p", p )
#  define PMS( s )         PMA( "%s", s )
#endif

#endif // TTL_DEFINE_H_
